SystemOrganization addCategory: #'SCouchDB-JQuery-Core'!

!JQueryClass methodsFor: '*scouchdb-jquery-core' stamp: 'JesusMari 3/30/2012 23:17'!
couch
	^ self create: JQCouch! !

JQPlugin subclass: #JQCouch
	instanceVariableNames: 'couchFunction command database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Core'!

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:47'!
activeTasks
self command:'activeTasks'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:23'!
allApps
self command:'allApps'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 14:30'!
allDbs
	self command:'allDbs'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:14'!
allDesignDocs
self command:'allDesignDocs'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 19:02'!
allDocs
self command:'allDocs'! !

!JQCouch methodsFor: 'accessing' stamp: 'JesusMari 4/3/2012 19:33'!
arguments
	| arguments jSonOptions|
	arguments := OrderedCollection new.
	jSonOptions:=Dictionary new.
	self options
		at: 'success'
		ifPresent: [ :value | jSonOptions at:'success' put: value ].
	self options
		at: 'eachApp'
		ifPresent: [ :value | jSonOptions at:'eachApp' put: value ].
	self options
		at: 'loginpassword'
		ifPresent: [ :value | jSonOptions at:'password' put: value ].
	self options
		at: 'name'
		ifPresent: [ :value | jSonOptions at:'name' put: value ].
	self options
		at: 'error'
		ifPresent: [ :value | jSonOptions at:'error' put: value ].
	self options
		at: 'reduce'
		ifPresent: [ :value | jSonOptions at:'reduce' put: value ].
	self options
		at: 'view'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'list'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'change'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'successUserDb'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'userDoc'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'password'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'replicateDb'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'replicateNewDb'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'doc'
		ifPresent: [ :value | arguments add: value ].						
	self options
		at: 'bulkDoc'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'mapFunction'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'reduceFunction'
		ifPresent: [ :value | arguments add: value ].						
	self options
		at: 'language'
		ifPresent: [ :value | arguments add: value ].	
							
	(jSonOptions size>0) ifTrue:[arguments add:jSonOptions].
	"this options after succcess...stupid order..."
	
	self options
		at: 'section'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'option'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'option-value'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'replicateTarget'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'beforeSend'
		ifPresent: [ :value | arguments add: value ].				
	^ arguments! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 19:37'!
beforeSend:aDocument 
"aDocument is a JSon doc with the beforeSend property that contains a jscript function"
	
|aDoc|
	aDoc:=Dictionary new.
	aDoc at:'beforeSend' put:( aDocument asFunction:#(xhr)).
	options at:'beforeSend' put:aDoc	
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/17/2013 08:50'!
bulkRemove:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	
	self command:'bulkRemove'.
	self optionAt: 'bulkDoc' put: aDocument.
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/17/2013 08:47'!
bulkSave:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	

	self command:'bulkSave'.
	self optionAt: 'bulkDoc' put: aDocument
! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 13:46'!
command
	^ command! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 13:46'!
command: anObject
	command := anObject! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:03'!
compact
self command:'compact'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:13'!
compactView:aView
"aView name example: 'default/all'"
	
	self command:'compactView'.
	self optionAt: 'view' put: aView.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:57'!
config:aSection option:anOption
self command:'config'.
self options at:'section'put:aSection.
self options at:'option' put:anOption! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:58'!
config:aSection option:anOption value:aValue
self command:'config'.
self options at:'section'put:aSection.
self options at:'option' put:anOption.
self options at:'option-value' put:aValue! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/9/2013 18:11'!
copyDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'copyDoc'.
	self optionAt: 'doc' put: (aDocument).
! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/29/2012 22:38'!
couchFunction
	^ couchFunction! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 01:16'!
couchFunction: aFunction
(aFunction isKindOf: BlockClosure)
ifTrue:[	couchFunction:= ((aFunction value)greaseString)]
ifFalse:[	couchFunction := aFunction ]! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 3/31/2012 08:24'!
create
command:='create'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 08:22'!
database
	^ Array with:database! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 08:23'!
database: anString
	database := anString.
	self couchFunction: [(JSStream on:'db') call:'' withArguments:(self database)].! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 3/31/2012 08:25'!
db:aDatabase

self database:aDatabase! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 19:21'!
drop
command:='drop'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 2/13/2013 00:59'!
encodeDocId: anString
	self couchFunction: [(JSStream on:'encodeDocId') call:'' withArguments:(Array with:anString)].
	   ! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 19:20'!
forEachApp: anObject
	self optionAt: 'eachApp' put: (anObject asFunction:#(appName appPath ddoc)).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 13:44'!
info
self command:'info'! !

!JQCouch methodsFor: 'accessing' stamp: 'JesusMari 7/24/2012 16:51'!
javascriptContentOn: aStream

	aStream
		javascript: self owner;
		nextPut: $.;
		nextPutAll: self method.
	
	couchFunction notNil ifTrue:[ 
		aStream  nextPut:$.;nextPutAll:couchFunction].
	command notNil ifTrue:[ 
		aStream nextPut:$. ;nextPutAll:command].
	self options size>0 ifTrue:[
		JSStream encodeArguments: self arguments on: aStream
		].
	"aStream nextPut:$;"
	
		
	! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:00'!
list:aView with:aList
"list a view with aList function'"
	
	self command:'list'.
	self optionAt: 'view' put: aView.
	self optionAt: 'list' put: aList.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:33'!
login:aUserName password:anString
"anUserName and password must be anString"

	self command:'login'.
	self optionAt: 'name' put: aUserName.
	self optionAt:'loginpassword' put: anString! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:45'!
logout
self command:'logout'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/29/2012 23:19'!
method
	^ 'couch'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/5/2012 05:54'!
newUUID
self command:'newUUID()'.! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 18:36'!
onChange: anObject
	self command:'changes().onChange'.
	self optionAt: 'change' put: (anObject asFunction:#(data)).
! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 3/31/2012 17:23'!
onError: anObject
	self optionAt: 'error' put: (anObject asFunction:#(status)).
! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 2/1/2013 13:15'!
onSuccess: anObject
	self optionAt: 'success' put: (anObject asFunction:#(data)).
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/9/2013 18:07'!
openDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'openDoc'.
	self optionAt: 'doc' put:aDocument.
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:33'!
query:mapFunction 
self query:mapFunction reduceFunction:'_count' language:'javascript'reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:22'!
query:mapFunction reduceFunction:reduceFunction 
self query:mapFunction reduceFunction:reduceFunction language:'javascript' reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:22'!
query:mapFunction reduceFunction:reduceFunction language:language 
self query:mapFunction reduceFunction:reduceFunction language:language reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:24'!
query:mapFunction reduceFunction:reduceFunction language:language reduce:aBoolean
self command:'query'.
self optionAt: 'mapFunction' put: mapFunction.
self optionAt: 'reduceFunction' put: reduceFunction. 
self optionAt: 'language' put: language.
self optionAt: 'reduce' put: aBoolean! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:50'!
reduce:aBoolean
self optionAt: 'reduce' put: aBoolean! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/9/2013 18:12'!
removeDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'removeDoc'.
	self optionAt: 'doc' put: (aDocument).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/1/2012 09:09'!
replicate:aDatabase to:aNewDatabase createTarget:aBoolean
"create_target must be a Dictionary wuth the following entrances:
{create_target:true}"
|createTarget|
	createTarget:=Dictionary new.
	createTarget at:'create_target' put: aBoolean.

	self command:'replicate'.
	self optionAt: 'replicateDb' put: aDatabase.
	self optionAt: 'replicateNewDb' put: aNewDatabase.
	self optionAt: 'replicateTarget' put: createTarget.! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 2/9/2013 18:09'!
saveDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	self command:'saveDoc'.
	self optionAt: 'doc' put: (aDocument).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:44'!
session
self command:'session'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:21'!
signUp:aUserName password:anString
"anUserDoc must be a Dictionary wuth the following entrances:
{_id:'org.couchdb.user:bob' , name:'bob'}"
|aUserDoc|
	aUserDoc:=Dictionary new.
	aUserDoc at:'_id' put: ('org.couchdb.user:',aUserName).
	aUserDoc at:'name' put:aUserName.
	self command:'signup'.
	self optionAt: 'userDoc' put: aUserDoc.
	self optionAt: 'password' put: anString.! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 2/13/2013 00:29'!
urlPrefix
		self couchFunction: [(JSStream on:'urlPrefix')].
	! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 4/5/2012 05:58'!
urlPrefix: anObject
		self couchFunction: [(JSStream on:'urlPrefix="',anObject,'"')].
	! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 17:00'!
userDb:aFunction
self command:'userDb'.
self optionAt: 'successUserDb' put: (aFunction asFunction:#(data)).! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:34'!
view:aView
"aView name example: 'default/all'"
	
	self command:'view'.
	self optionAt: 'view' put: aView.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/3/2012 18:08'!
viewCleanup
self command:'viewCleanup'! !

!WAFileUploadTag methodsFor: '*scouchdb-jquery-core' stamp: 'JesusMari 2/13/2013 18:13'!
multiple
	"When set to true, this boolean attribute allows multiple file uploading"
	self attributes at: 'multiple' put: true! !
